SystemOrganization addCategory: #'Fuel-Tests'!
SystemOrganization addCategory: #'Fuel-Core'!
SystemOrganization addCategory: #'Fuel-Core-Cluster'!

!SmallInteger methodsFor: '*Fuel' stamp: 'MartinDias 9/27/2010 14:17'!
fuelSerializer
	^ self < 0 
		ifTrue: [ FLSmallIntegerNegativeClusterSerializer instance ]
		ifFalse: [ FLSmallIntegerClusterSerializer instance ]
	! !

!Trait methodsFor: '*Fuel-analysis' stamp: 'MartinDias 10/4/2010 23:31'!
fuelAccept: aVisitor

	aVisitor visitTrait: self! !

!Trait methodsFor: '*Fuel' stamp: 'MartinDias 10/4/2010 23:29'!
fuelSerializer 
	^ FLGlobalClusterSerializer instance.! !

!CompiledMethod methodsFor: '*Fuel-analysis' stamp: 'MartinDias 10/6/2010 20:57'!
fuelAccept: aVisitor
	aVisitor visitCompiledMethod: self! !

!CompiledMethod methodsFor: '*Fuel-analysis' stamp: 'MartinDias 10/6/2010 21:00'!
fuelAllInstanceVariablesAccept: aVisitor

	1 to: self numLiterals
		do: [ :index | (self literalAt: index) fuelAccept: aVisitor ]! !

!CompiledMethod methodsFor: '*Fuel' stamp: 'MartinDias 9/29/2010 16:40'!
fuelSerializer 
	^ FLCompiledMethodClusterSerializer instance.! !

!Symbol methodsFor: '*Fuel' stamp: 'MartinDias 9/23/2010 17:41'!
fuelSerializer

	^ FLSymbolClusterSerializer instance! !

!UndefinedObject methodsFor: '*Fuel-analysis' stamp: 'MartinDias 9/28/2010 13:28'!
fuelAccept: aVisitor
	aVisitor visitNilTrueFalse: self.! !

!UndefinedObject methodsFor: '*Fuel' stamp: 'TristanBourgois 9/24/2010 13:56'!
fuelSerializer 

	^ FLNilTrueFalseClusterSerializer instance! !

!LargePositiveInteger methodsFor: '*fuel' stamp: 'TristanBourgois 9/24/2010 14:21'!
fuelSerializer 

	^ FLLargePositiveIntegerClusterSerializer instance.! !

!Character methodsFor: '*Fuel' stamp: 'MartinDias 9/23/2010 17:41'!
fuelSerializer

	^ FLCharacterClusterSerializer instance! !

TestCase subclass: #FLClusterSerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLClusterSerializerTest methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 15:09'!
testUniqueIds

	" 
	Inspect the mapping:
	FLClusterSerializer allSubclasses collect: [ :aClass | aClass->([aClass new id] ifError: [nil]) ]
	"

	| ids |
	ids := FLClusterSerializer allSubclasses 
		collect: [ :aClass | [aClass new id] ifError: [nil] ] 
		thenSelect: [ :obj | obj isNil not].
	self 
		assert: ids size = ids asSet size 
		description: 'Same id detected on two FLClusterSerializer subclasses'! !

TestCase subclass: #FLSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLSerializationTest commentStamp: '<historical>' prior: 0!
I have black-box tests for testing that objects serializes and materializes well.!

FLSerializationTest subclass: #FLBasicSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testCharacter
	self assertSerializationIdentityOf: $a! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testCycleLinks
	| a b c materializedPairs materializedA |
	a := Link new..
	b := Link  new.
	c := Link new.
	
	a nextLink:b.
	b nextLink: c.
	c nextLink: a.
	
	materializedPairs := self materializedRootsOfAll: {a}..
	
	self assert: materializedPairs size = 1.
	
	materializedA := materializedPairs anyOne.
	"We can't check the equality of the links because a link is check on his
	identity. So we only check the structure of the cycle'"
	self assert: materializedA nextLink nextLink nextLink == materializedA.
	self deny: materializedA nextLink == materializedA.
	self deny: materializedA nextLink nextLink == materializedA.! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testCyclePairs
	| a b c materializedPairs materializedA |
	a := Pair new.
	b := Pair new.
	c := Pair new.
	
	a left: 1; right: b.
	b left: 2; right: c.
	c left: 3; right: a.
	
	materializedPairs := self materializedRootsOfAll: {a}..
	
	self assert: materializedPairs size = 1.
	
	materializedA := materializedPairs anyOne.
	"We can't check the equality of the links because a link is check on his
	identity. So we only check the structure of the cycle'"
	self assert: materializedA right right right == materializedA.
	self deny: materializedA right == materializedA.
	self deny: materializedA right right == materializedA.! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testDictionary
	self assertSerializationEqualityOf: (Dictionary with: 1->2 with: #toto->'toto' with: 3->4).! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testFalse
	self assertSerializationIdentityOf: false! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testLargeNegativeInteger

self assertSerializationEqualityOf: -35431431613431399999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999.! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testLargePositiveInteger

self assertSerializationEqualityOf: 35431431613431399999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999.! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testMaxSmallInteger
	self assertSerializationIdentityOf: SmallInteger maxVal .
	! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testMinSmallIntegerNegative

	self assertSerializationEqualityOf: SmallInteger minVal ! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testNil
	self assertSerializationIdentityOf: nil! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testOrderedCollection

	self assertSerializationEqualityOf: (OrderedCollection with: 10 with: 20)! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testPair
	self assertSerializationEqualityOf:
			(Pair new
				left: 20;
				right: 30;
				yourself)! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testPoint
	self assertSerializationEqualityOf: 10@20! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testRectangule
	
	self assertSerializationEqualityOf: (10@20 corner: 30@40)! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testSmallInteger
	self assertSerializationIdentityOf: SmallInteger one.! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testSmallInteger0

	self assertSerializationIdentityOf: 0.! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testSmallIntegerNegative

	self assertSerializationIdentityOf: -42.! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testString
	self assertSerializationEqualityOf: 'tototototototototototototototototototo'! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testSymbol
	self assertSerializationIdentityOf: #totototototototo! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testToto
	| t |
	t := Titi new.
	t with: 'toto' with: 'titi' with: 20.
	self assertSerializationEqualityOf: t! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testTrue
	self assertSerializationIdentityOf: true! !

FLSerializationTest subclass: #FLClassSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLClassSerializationTest methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/4/2010 16:35'!
testForeignClass
	"Tests the serialization of a class that is not being exported"
	
	self assertSerializationIdentityOf: Pair! !

!FLClassSerializationTest methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/4/2010 16:52'!
testForeignMetaclass
	"Tests the serialization of a metaclass that is not being exported"
	
	self assertSerializationIdentityOf: Pair class! !

!FLClassSerializationTest methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/4/2010 16:52'!
testForeignTrait
	"Tests the serialization of a trait that is not being exported"
	
	self assertSerializationIdentityOf: TPureBehavior! !

FLSerializationTest subclass: #FLCompiledMethodSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/30/2010 11:18'!
fortyTwo
	^ 42! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/7/2010 00:46'!
testMethodWithSmallIntegerLiteral

	| compiledMethod results materializedCompiledMethod |
	compiledMethod := self class methodDictionary at: #fortyTwo.

	results := self materializedRootsOfAll: { compiledMethod }..
	
	self assert: 1 equals: results size.	
	materializedCompiledMethod := results anyOne.
"	self assert: materializedCompiledMethod = compiledMethod.	"
	self deny: materializedCompiledMethod == compiledMethod.
	self assert: 42 equals: (materializedCompiledMethod valueWithReceiver: self arguments: #()).! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/7/2010 00:45'!
testYourselfMethod

	| compiledMethod results materializedCompiledMethod |
	compiledMethod := Object methodDictionary at: #yourself.

	results := self materializedRootsOfAll: { compiledMethod }..
	
	self assert: 1 equals: results size.	
	materializedCompiledMethod := results anyOne.
"	self assert: materializedCompiledMethod = compiledMethod."
	self deny: materializedCompiledMethod == compiledMethod.
	self assert: self == (materializedCompiledMethod valueWithReceiver: self arguments: #()).! !

FLSerializationTest subclass: #FLCrowdedSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLCrowdedSerializationTest commentStamp: '<historical>' prior: 0!
I have tests with large samples, so I'm very slow to be run frequently.!

!FLCrowdedSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:17'!
testCrowdedRoot

	| roots |
	roots := Set new.
	1 to: (2 raisedTo: 17) do: [ :index | roots add: index ].

	self assertSerializationEqualityOfAll: roots! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:28'!
assertSerializationEqualityOf: anObject

	self assertSerializationEqualityOfAll: {anObject}! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/6/2010 09:53'!
assertSerializationEqualityOfAll: rootsCollection
	| materializedRoots |
	materializedRoots := self materializedRootsOfAll: rootsCollection..		
	self assert: rootsCollection size equals: materializedRoots size.
	self should: [ rootsCollection includesAllOf: materializedRoots ]! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/6/2010 09:53'!
assertSerializationIdentityOf: anObject
	| materializedRoots |
	materializedRoots := self materializedRootsOfAll: {anObject}.
	self assert: 1 equals: materializedRoots size.
	self should: [ anObject == materializedRoots anyOne ]! !

!FLSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:28'!
materializedRootsOfAll: rootsCollection
	| aByteArray aSerializer |

	aSerializer := FLSerializer on: (RWBinaryOrTextStream on: '') binary.
	aByteArray := (aSerializer serializeAll: rootsCollection) stream contents.
	^ (FLMaterializer on: aByteArray readStream) 
			materialize;
			materializedRoots
! !

!Boolean methodsFor: '*Fuel-analysis' stamp: 'MartinDias 9/28/2010 13:29'!
fuelAccept: aVisitor
	aVisitor visitNilTrueFalse: self.! !

!Boolean methodsFor: '*Fuel' stamp: 'MartinDias 9/27/2010 09:15'!
fuelSerializer 

	^ FLNilTrueFalseClusterSerializer instance ! !

!Metaclass methodsFor: '*Fuel-analysis' stamp: 'MartinDias 10/5/2010 10:54'!
fuelAccept: aVisitor
	aVisitor visitMetaclass: self! !

!Metaclass methodsFor: '*Fuel' stamp: 'MartinDias 10/5/2010 10:58'!
fuelSerializer 
	^ FLMetaclassClusterSerializer instance.! !

!Class methodsFor: '*Fuel-analysis' stamp: 'MartinDias 10/4/2010 22:05'!
fuelAccept: aVisitor

	aVisitor visitClass: self! !

!Class methodsFor: '*Fuel' stamp: 'MartinDias 10/4/2010 23:25'!
fuelSerializer 
	^ FLGlobalClusterSerializer instance.! !

!LargeNegativeInteger methodsFor: '*fuel' stamp: 'TristanBourgois 9/24/2010 15:09'!
fuelSerializer 

	^ FLLargeNegativeIntegerClusterSerializer instance.! !

Object subclass: #FLBenchmarks
	instanceVariableNames: 'writeStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLBenchmarks commentStamp: '<historical>' prior: 0!
Do it on one of the following lines:

FLBenchmarks new runBenchWith: FLBenchmarks new strings
FLBenchmarks new runBenchWith: FLBenchmarks new symbols
FLBenchmarks new runBenchWith: FLBenchmarks new smallIntegers 

FLBenchmarks new runBenchWith: FLBenchmarks new points
FLBenchmarks new runBenchWith: FLBenchmarks new pairs
FLBenchmarks new runBenchWith: FLBenchmarks new rectangles 

FLBenchmarks new runBenchWith: FLBenchmarks new completeBinaryTree

FLBenchmarks new runBenchWith: FLBenchmarks new smallOrderedCollections 
FLBenchmarks new runBenchWith: FLBenchmarks new orderedCollectionWithRepeatedElement 

FLBenchmarks new runBenchWith: FLBenchmarks new titis
!

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 10/6/2010 11:27'!
completeBinaryTree 
	| aCollection numberOfLeafs |
	numberOfLeafs := 2 raisedTo: 14.
	aCollection := OrderedCollection new.
	1 to: numberOfLeafs do: [ :i | 
		aCollection add: (
			Pair new 
				left: (2 * i); 
				right: (2 * i) + 1) ].
	
	[aCollection size > 1] 
		whileTrue: [
			aCollection := aCollection pairsCollect: [ :leftPair :rightPair | 
				Pair new 
					left: leftPair;
					right: rightPair;
					yourself ] ].
	^aCollection! !

!FLBenchmarks methodsFor: 'initialization' stamp: 'MartinDias 9/29/2010 10:57'!
initialize 
	writeStream := Transcript! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 10/6/2010 11:20'!
orderedCollectionWithRepeatedElement
	| aCollection |
	aCollection := OrderedCollection new.
	(2 raisedTo: 15) timesRepeat: [ aCollection add: 17 ].
	^aCollection.! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 10/6/2010 11:27'!
pairs
	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new.
	1 to: (2 raisedTo: 15) by: 2 do: [ :i | 
		anOrderedCollection add: (Pair new left: i; right: i+1)].
	^ anOrderedCollection! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 10/6/2010 11:27'!
points
	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new.
	1 to: (2 raisedTo: 15) by: 2 do: [ :i | anOrderedCollection add: i@(i+1)].
	^ anOrderedCollection! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 9/20/2010 23:40'!
rectangles
	| rectangles |
	rectangles := OrderedCollection new.
	1 to: (2 raisedTo: 15) by: 4 do: [ :i | 
		rectangles add: (i@(i+1) corner: (i+2)@(i+3))].
	^rectangles.! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 10/6/2010 19:08'!
runBenchWith: aCollection
	| benchSelectors |
	
	Transcript clear.
	
	benchSelectors := #( 
		#runFuelBenchWith: 
		#runReferenceStreamBenchWith:
		"#runSmartRefStreamBenchWith:" 
		"#runMagmaBenchWith:"
		"#runMC2BenchWith:").

	benchSelectors do: [ :aSelector |
		self perform: aSelector with: aCollection.
		Smalltalk garbageCollect.
		Transcript cr; flush.
	]! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 9/29/2010 10:54'!
runFuelBenchWith: aCollection

	| serializer materializer |

	writeStream nextPutAll: '= Fuel Serialization ='; cr.
	self spy: [ 
		serializer := FLSerializer on: (RWBinaryOrTextStream on: '') binary.
		serializer serializeAll: aCollection.
	].

	writeStream nextPutAll: '= Fuel Materialization ='; cr.
	materializer := FLMaterializer on: serializer stream contents readStream.
	self spy: [ materializer materialize ]
! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 9/22/2010 13:37'!
runMC2BenchWith: aCollection
"
	| serializer writeStream |

	writeStream := (RWBinaryOrTextStream on: '') binary.

	Transcript show: '= MC2 Serialization ='; cr.
	self spy: [
		serializer := MDSerializer on: writeStream. 
		serializer serialize: aCollection ]
			putResultsOn: Transcript.

	Transcript show: '= MC2 Materialization ='; cr.
	self spy: [ 
		MDMaterializer materialize: writeStream contents ] 
			putResultsOn: Transcript."! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 9/29/2010 11:00'!
runMagmaBenchWith: aCollection

	| aSerializer aGraphBuffer anotherSerializer aByteArray |
	
	writeStream nextPutAll: '= Magma Serialization ='; cr.
	aSerializer := MaObjectSerializer new.
	self spy: [ 
		aGraphBuffer := aSerializer serializeGraph: aCollection.
	].
 
	writeStream nextPutAll: '= Magma Materialization ='; cr.
	anotherSerializer := MaObjectSerializer new.
	aByteArray := aGraphBuffer byteArray copy.
	self spy: [ anotherSerializer materializeGraph: aByteArray ]! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 10/6/2010 11:11'!
runReferenceStreamBenchWith: aCollection

	| stream materializedObjects |

	writeStream nextPutAll: '= ReferenceStream Serialization ='; cr.
	stream := ReferenceStream on: (RWBinaryOrTextStream on: '') binary.
	self spy: [
		stream nextPutAll: aCollection.
	].

	writeStream nextPutAll: '= ReferenceStream Materialization ='; cr.
	stream := ReferenceStream on:  stream contents readStream.
	materializedObjects := OrderedCollection new.
	self spy: [
		[ stream atEnd ] 
			whileFalse: [
				"materializedObjects add: "stream next ]
	]! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 10/6/2010 11:10'!
runSmartRefStreamBenchWith: aCollection

	| stream materializedObjects |

	writeStream nextPutAll: '= SmartRefStream Serialization ='; cr.
	stream := SmartRefStream on: (RWBinaryOrTextStream on: '') binary.
	self spy: [
		stream nextPutAll: aCollection.
	].

	writeStream nextPutAll: '= SmartRefStream Materialization ='; cr.
	stream := SmartRefStream on:  stream contents readStream.
	materializedObjects := OrderedCollection new.
	self spy: [
		[ stream atEnd ] 
			whileFalse: [
				materializedObjects add: stream next ]
	]! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 10/6/2010 11:26'!
smallIntegers
	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new.
	1 to: (2 raisedTo: 30) by: (2 raisedTo: 13) do: [ :i | anOrderedCollection add: i ].
	^ anOrderedCollection! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 10/6/2010 11:26'!
smallOrderedCollections
	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new.
	1 to: (2 raisedTo: 14) by: 2 do: [ :i | 
		anOrderedCollection add: (OrderedCollection with: i with: i+1)].
	^ anOrderedCollection.! !

!FLBenchmarks methodsFor: 'testing' stamp: 'MartinDias 9/29/2010 10:53'!
spy: aBlockClosure

	writeStream nextPutAll: 'time to run (ms): ', aBlockClosure timeToRun printString; cr. ! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 10/6/2010 11:28'!
strings
	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new.
	1 to: (2 raisedTo: 15) do: [ :index | anOrderedCollection add: (index" * 123456790") asString ].
	^ anOrderedCollection! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 10/6/2010 11:25'!
symbols
	| anOrderedCollection allSymbols |
	anOrderedCollection := OrderedCollection new.
	allSymbols := Symbol allSymbols.
	1 to: (2 raisedTo: 12) do: [ :index | 
		anOrderedCollection add: (allSymbols at: index) ].
	^ anOrderedCollection! !

!FLBenchmarks methodsFor: 'samples' stamp: 'MartinDias 10/6/2010 11:25'!
titis
	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new.
	1 to: (2 raisedTo: 15) do: [ :i | anOrderedCollection add: (Titi with: 'toto' with:'titi'  with:i) ].
	^anOrderedCollection.! !

Object subclass: #FLClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 14:35'!
id
	"Answer an unique byte identifier"
	self subclassResponsibility ! !

!FLClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/11/2010 21:31'!
materializeOn: aReadStream addTo: aCollection mainMaterializer: aMaterializer

	self subclassResponsibility ! !

!FLClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/12/2010 16:18'!
serializeAll: clusterInstances on: aWriteStream mainSerializer: aSerializer

	self subclassResponsibility ! !

FLClusterSerializer subclass: #FLIteratingClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

FLIteratingClusterSerializer subclass: #FLCompiledMethodClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLCompiledMethodClusterSerializer classSide methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/30/2010 11:27'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!FLCompiledMethodClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/30/2010 11:29'!
id
	^2! !

!FLCompiledMethodClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/7/2010 00:36'!
materializeLiteralsTo: compiledMethod with: aMaterializer

	1 to: compiledMethod numLiterals 
		do: [ :index | compiledMethod literalAt: index put: aMaterializer nextReferencedObject ]
! !

!FLCompiledMethodClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/7/2010 00:45'!
materializeWith: aMaterializer

	| compiledMethod header source trailer numberOfBytesForAllButTrailer aReadStream |

	aReadStream := aMaterializer stream.

	header := (aReadStream nextWord << 16) bitOr: aReadStream nextWord.
	numberOfBytesForAllButTrailer := aReadStream nextWord.
	source := aReadStream nextString.

	trailer := CompiledMethodTrailer new 
		sourceCode: source; 
		yourself.

	compiledMethod := trailer createMethod: numberOfBytesForAllButTrailer header: header.

	compiledMethod initialPC - 1 to: numberOfBytesForAllButTrailer
		do: [ :index | compiledMethod at: index put: aReadStream next ].

	aMaterializer referenceMaterializingActions 
		add: [ self materializeLiteralsTo: compiledMethod with: aMaterializer ].
		
	^ compiledMethod! !

!FLCompiledMethodClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/7/2010 00:45'!
serialize: aCompiledMethod with: aSerializer

	| header source aWriteStream numberOfBytesForAllButTrailer |

	aWriteStream := aSerializer stream.

	header := aCompiledMethod header.
	numberOfBytesForAllButTrailer := aCompiledMethod size - aCompiledMethod trailer size.
	source := aCompiledMethod getSource.

	aWriteStream 
		nextWordPut: (header >> 16);
		nextWordPut: header;
		nextWordPut: numberOfBytesForAllButTrailer;
		nextStringPut: source asString.

	aCompiledMethod initialPC - 1 to: aCompiledMethod endPC
		do: [ :index | aWriteStream nextPut: (aCompiledMethod at: index) ].

	aSerializer referenceSerializingActions 
		add: [ self serializeLiteralsOf: aCompiledMethod with: aSerializer ]! !

!FLCompiledMethodClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/7/2010 00:36'!
serializeLiteralsOf: aCompiledMethod with: aSerializer

	1 to: aCompiledMethod numLiterals 
		do: [ :index | aSerializer nextPutReferenceTo: (aCompiledMethod literalAt: index) ]! !

!FLIteratingClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/5/2010 14:26'!
materializeOn: aReadStream addTo: aCollection mainMaterializer: aMaterializer

	| instanceCount |
	instanceCount := aMaterializer nextInteger.

	instanceCount timesRepeat: 
		[aCollection add: 
			(self materializeWith: aMaterializer)].! !

!FLIteratingClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/5/2010 14:26'!
materializeWith: aMaterializer

	^ self subclassResponsibility! !

!FLIteratingClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/5/2010 14:27'!
serialize: aMetaclass with: aSerializer

	self subclassResponsibility ! !

!FLIteratingClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/5/2010 14:26'!
serializeAll: aCollection on: aWriteStream mainSerializer: aSerializer
	aSerializer nextPutInteger: aCollection size.
	aCollection do: [ :instance | self serialize: instance with: aSerializer ]! !

FLIteratingClusterSerializer subclass: #FLMetaclassClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLMetaclassClusterSerializer classSide methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/5/2010 11:25'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!FLMetaclassClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/5/2010 11:00'!
id
	^ 12! !

!FLMetaclassClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/5/2010 14:28'!
materializeWith: aMaterializer

	^ aMaterializer nextReferencedObject class.! !

!FLMetaclassClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/5/2010 14:28'!
serialize: aMetaclass with: aSerializer

	aSerializer nextPutReferenceTo: aMetaclass soleInstance.
! !

FLClusterSerializer subclass: #FLObjectClusterSerializer
	instanceVariableNames: 'clusterClass'
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLObjectClusterSerializer classSide methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 01:34'!
for: aClass

	^ self basicNew
		initialize: aClass;
		yourself.! !

!FLObjectClusterSerializer classSide methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 01:34'!
instance
	^ Instance ifNil: [ Instance := self for: Object ]! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 02:04'!
= another
	^ (another isKindOf: FLObjectClusterSerializer) and: [ clusterClass = another clusterClass]! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 02:04'!
clusterClass
	^ clusterClass ! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 02:43'!
hash
	^ clusterClass hash! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 16:39'!
id

	^0! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 01:31'!
initialize: aClass

	clusterClass := aClass! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/4/2010 22:16'!
materializeOn: aReadStream addTo: aCollection mainMaterializer: aMaterializer

	| instanceCount className class clusterInstances |
	class := aMaterializer nextReferencedObject.
	instanceCount := aMaterializer nextInteger.
	clusterInstances := OrderedCollection new: instanceCount.

	class isVariable 
		ifTrue: [
			instanceCount timesRepeat: [ clusterInstances add: (class basicNew: aMaterializer nextInteger) ].
			aMaterializer referenceMaterializingActions 
				add: [ self materializeVariableReferencesOfAll: clusterInstances on: aReadStream mainMaterializer: aMaterializer ] ]
		ifFalse: [
			instanceCount timesRepeat: [ clusterInstances add: class basicNew ] ].

	class instSize > 0
		ifTrue: [
			aMaterializer referenceMaterializingActions 
				add: [ self materializeReferencesOfAll: clusterInstances on: aReadStream mainMaterializer: aMaterializer ]].

	aCollection addAll: clusterInstances.
! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/6/2010 19:11'!
materializeReferencesOfAll: instances on: stream mainMaterializer: aMaterializer
	
	| numberOfInstanceVariables |
	numberOfInstanceVariables := instances anyOne class instSize.
	instances
		do: [ :instance |
			1 to: numberOfInstanceVariables 
				do: [ :index | instance instVarAt: index put: aMaterializer nextReferencedObject ]]! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 16:58'!
materializeVariableReferencesOfAll: instances on: stream mainMaterializer: aMaterializer
	instances
		do: [ :instance |
			1 to: instance basicSize 
				do: [ :index | instance basicAt: index put: aMaterializer nextReferencedObject ]]! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/4/2010 22:15'!
serializeAll: clusterInstances on: aWriteStream mainSerializer: aSerializer

	aSerializer nextPutReferenceTo: clusterClass.
	aSerializer nextPutInteger: clusterInstances size.

	clusterClass isVariable 
		ifTrue: [
			clusterInstances do: [ :instance | aSerializer nextPutInteger: instance basicSize].
			
			aSerializer referenceSerializingActions 
				add: [self serializeVariableReferencesOfAll: clusterInstances on: aWriteStream mainSerializer: aSerializer ]].

	clusterClass instSize > 0 
		ifTrue: [ 
			aSerializer referenceSerializingActions 
				add: [self serializeReferencesOfAll: clusterInstances on: aWriteStream mainSerializer: aSerializer ]]
			
! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/27/2010 10:38'!
serializeReferencesOfAll: instances on: stream mainSerializer: aSerializer 
	| class size |
	
	class := instances anyOne class.
	size := class instSize.
	instances 
		do: [ :anInstance |
			1 to: size do: [ :index |
				aSerializer nextPutReferenceTo: (anInstance instVarAt: index) ]]
				
	! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/27/2010 10:38'!
serializeVariableReferencesOfAll: instances on: aWriteStream mainSerializer: aSerializer

	instances 
		do: [ :anInstance |
			1 to: anInstance basicSize do: [ :index |
				aSerializer nextPutReferenceTo: (anInstance basicAt: index) ]]! !

FLClusterSerializer subclass: #FLPrimitiveClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

FLPrimitiveClusterSerializer subclass: #FLCharacterClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLCharacterClusterSerializer classSide methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 17:45'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!FLCharacterClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 15:08'!
id

	^1! !

!FLCharacterClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/23/2010 12:34'!
materializeOn: aReadStream

	^Character value:(aReadStream next)! !

!FLCharacterClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/27/2010 13:44'!
serialize: aCharacter on: aWriteStream

	aWriteStream nextPut: aCharacter value.! !

FLPrimitiveClusterSerializer subclass: #FLGlobalClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLGlobalClusterSerializer classSide methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/4/2010 21:52'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!FLGlobalClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/4/2010 22:11'!
id
	^ 11! !

!FLGlobalClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/4/2010 21:49'!
materializeOn: aReadStream

	| className |
	className := aReadStream nextString.
	^ Smalltalk at: className asSymbol! !

!FLGlobalClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 10/4/2010 21:49'!
serialize: aClass on: aWriteStream

	aWriteStream nextStringPut: aClass name.! !

FLPrimitiveClusterSerializer subclass: #FLLargeNegativeIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLLargeNegativeIntegerClusterSerializer classSide methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 15:05'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!FLLargeNegativeIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 15:06'!
id
	^8! !

!FLLargeNegativeIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 15:12'!
materializeOn: aReadStream

	| size value |
	size:=aReadStream next.
	value := 0.
	size timesRepeat: [value := (value bitShift: 8) bitOr: aReadStream next].
	^ value negated ! !

!FLLargeNegativeIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 15:12'!
serialize: anInteger on: aWriteStream

	| size byte positive |
	positive:=anInteger abs.
	size:=(positive log: 256) floor + 1.
	aWriteStream nextPut:size.
	(size - 1 to: 0 by: -1) do:
		[:index |
		byte := (positive bitShift: index * -8) bitAnd: 255.
		aWriteStream nextPut: byte]! !

FLPrimitiveClusterSerializer subclass: #FLLargePositiveIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLLargePositiveIntegerClusterSerializer classSide methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 14:10'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!FLLargePositiveIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/27/2010 14:15'!
id
	^7! !

!FLLargePositiveIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 14:19'!
materializeOn: aReadStream

	| size value |
	size:=aReadStream next.
	value := 0.
	size timesRepeat: [value := (value bitShift: 8) bitOr: aReadStream next].
	^ value! !

!FLLargePositiveIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/27/2010 13:42'!
serialize: anInteger on: aWriteStream

	| size byte |
	size:=(anInteger log: 256) floor + 1.
	aWriteStream nextPut: size.
	(size - 1 to: 0 by: -1) do:
		[:index |
		byte := (anInteger bitShift: index * -8) bitAnd: 255.
		aWriteStream nextPut: byte]! !

FLPrimitiveClusterSerializer subclass: #FLNilTrueFalseClusterSerializer
	instanceVariableNames: 'primitiveDict'
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLNilTrueFalseClusterSerializer classSide methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 13:36'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!FLNilTrueFalseClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 13:36'!
id

	^4! !

!FLNilTrueFalseClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 13:55'!
initialize 
	primitiveDict :=Dictionary new.
	primitiveDict add: nil-> 1;
	add: true ->2;
	add: false -> 3.  ! !

!FLNilTrueFalseClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 13:58'!
materializeOn: aReadStream
	
	^ primitiveDict keyAtValue: aReadStream next
	! !

!FLNilTrueFalseClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/24/2010 13:45'!
serialize: aPrimitive on: aWriteStream

	aWriteStream nextPut: (primitiveDict at:aPrimitive)! !

!FLPrimitiveClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 17:50'!
materializeOn: aReadStream

	self subclassResponsibility ! !

!FLPrimitiveClusterSerializer methodsFor: 'materializing' stamp: 'MartinDias 9/27/2010 14:51'!
materializeOn: aReadStream addTo: aCollection mainMaterializer: aMaterializer 
	
	| instanceCount |
	instanceCount := aMaterializer nextInteger.

	instanceCount timesRepeat: 
		[aCollection add: 
			(self materializeOn: aReadStream)].! !

!FLPrimitiveClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/29/2010 16:46'!
serialize: anObject on: aWriteStream
	self subclassResponsibility! !

!FLPrimitiveClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/27/2010 14:53'!
serializeAll: aCollection on: aWriteStream mainSerializer: aSerializer
	aSerializer nextPutInteger: aCollection size.
	aCollection do: [ :instance | self serialize: instance on: aWriteStream ]! !

FLPrimitiveClusterSerializer subclass: #FLSmallIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLSmallIntegerClusterSerializer classSide methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/27/2010 14:21'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!FLSmallIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 00:46'!
id
	^9! !

!FLSmallIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 00:47'!
materializeOn: aReadStream

	| hi mid1 mid2 lo |
	hi := aReadStream next.
	mid2 := aReadStream next.
	mid1 := aReadStream next.
	lo := aReadStream next.
	^ (hi bitShift: 24) + (mid2 bitShift: 16) + (mid1 bitShift: 8) + lo! !

!FLSmallIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/24/2010 00:48'!
serialize: anInteger on: aWriteStream

	aWriteStream nextPut: (anInteger bitShift: -24).
	aWriteStream nextPut: ((anInteger bitShift: -16) bitAnd: 255).
	aWriteStream nextPut: ((anInteger bitShift: -8) bitAnd: 255).
	aWriteStream nextPut: (anInteger bitAnd: 255).! !

FLPrimitiveClusterSerializer subclass: #FLSmallIntegerNegativeClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLSmallIntegerNegativeClusterSerializer classSide methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/27/2010 14:12'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!FLSmallIntegerNegativeClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/27/2010 14:12'!
id
	^10! !

!FLSmallIntegerNegativeClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/27/2010 14:14'!
materializeOn: aReadStream

	| hi mid1 mid2 lo |
	hi := aReadStream next.
	mid2 := aReadStream next.
	mid1 := aReadStream next.
	lo := aReadStream next.
	^ ((hi bitShift: 24) + (mid2 bitShift: 16) + (mid1 bitShift: 8) + lo) negated! !

!FLSmallIntegerNegativeClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/27/2010 14:13'!
serialize: anInteger on: aWriteStream

	| aPositiveInteger |
	
	aPositiveInteger := anInteger abs.
	aWriteStream nextPut: (aPositiveInteger bitShift: -24).
	aWriteStream nextPut: ((aPositiveInteger bitShift: -16) bitAnd: 255).
	aWriteStream nextPut: ((aPositiveInteger bitShift: -8) bitAnd: 255).
	aWriteStream nextPut: (aPositiveInteger bitAnd: 255).! !

FLPrimitiveClusterSerializer subclass: #FLStringClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLStringClusterSerializer classSide methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 17:46'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!FLStringClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 15:08'!
id

	^5! !

!FLStringClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/23/2010 08:47'!
materializeOn: aReadStream

	
	^ aReadStream nextString
	! !

!FLStringClusterSerializer methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/23/2010 08:45'!
serialize: aString on: aWriteStream

	aWriteStream nextPut: (aString).! !

FLPrimitiveClusterSerializer subclass: #FLSymbolClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLSymbolClusterSerializer classSide methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 17:46'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!FLSymbolClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 11:00'!
id

	^3! !

!FLSymbolClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 11:08'!
materializeOn: aReadStream

	| size aByteArray  |
	size := aReadStream nextWord.
	aByteArray := aReadStream next: size.
	^ aByteArray asString asSymbol ! !

!FLSymbolClusterSerializer methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/23/2010 10:57'!
serialize: aSymbol on: aWriteStream

	aWriteStream nextWordPut: aSymbol  size.
	aWriteStream nextPutAll: aSymbol asString.! !

Object subclass: #FLMaterializer
	instanceVariableNames: 'stream clusterSerializers referenceMaterializingActions materializedInstances materializedRoots integerMaterializer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLMaterializer class methodsFor: 'creation' stamp: 'MartinDias 9/20/2010 20:34'!
on: aReadStream

	^self new
		stream: aReadStream; 
		yourself
! !

!FLMaterializer methodsFor: 'private' stamp: 'sd 9/8/2010 15:47'!
clusterSerializerFor: id

	^clusterSerializers at: id.! !

!FLMaterializer methodsFor: 'initialize-release' stamp: 'MartinDias 10/6/2010 23:29'!
initialize 
	
	referenceMaterializingActions := OrderedCollection new.
	
	clusterSerializers := IdentityDictionary new.
	self register: FLObjectClusterSerializer instance.
	self register: FLSymbolClusterSerializer instance.
	self register: FLNilTrueFalseClusterSerializer instance.
	self register: FLCharacterClusterSerializer instance.
	self register: FLLargePositiveIntegerClusterSerializer instance.
	self register: FLLargeNegativeIntegerClusterSerializer instance.
	self register: FLSmallIntegerClusterSerializer instance.
	self register: FLSmallIntegerNegativeClusterSerializer instance.	
	self register: FLGlobalClusterSerializer instance.
	self register: FLMetaclassClusterSerializer instance.
	self register: FLCompiledMethodClusterSerializer instance.
	
"	* For automatically add cluster serializers * 
	FLClusterSerializer allSubclasses 
		select: [ :aSerializerClass | aSerializerClass canUnderstand: #id ] 
		thenDo: [ :aSerializerClass | 
			| aSerializer |
			aSerializer := aSerializerClass new.
			clusterSerializers 
				at: aSerializer id 
				put: aSerializer ]."! !

!FLMaterializer methodsFor: 'materializing' stamp: 'MartinDias 9/22/2010 14:37'!
materialize
	self materializeInstances.
	self materializeReferences.
	self materializeRoots.! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 9/11/2010 19:22'!
materializeCluster
	| clusterSerializerId instanceCount clusterSerializer |
	clusterSerializerId := stream nextWord.
	clusterSerializer := self clusterSerializerFor: clusterSerializerId.
	clusterSerializer materializeOn: stream addTo: materializedInstances mainMaterializer: self! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 10/4/2010 22:31'!
materializeInstances

	| clusterCount objectCount |

	integerMaterializer := self clusterSerializerFor: stream nextWord.

	objectCount := self nextInteger.
	materializedInstances := OrderedCollection new: objectCount.

	clusterCount := self nextInteger.
	clusterCount timesRepeat: [self materializeCluster].
! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 9/11/2010 19:08'!
materializeReferences

	referenceMaterializingActions
		do: [ :aBlock | aBlock value ]
! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 10/4/2010 23:06'!
materializeRoots

	| rootsSize |
	
	rootsSize := self nextInteger.
	materializedRoots := OrderedCollection new: rootsSize.
	rootsSize timesRepeat: [ materializedRoots add: self nextReferencedObject ]! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 9/21/2010 00:32'!
materializedInstances
	^ materializedInstances! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 9/27/2010 14:50'!
materializedRoots
	^ materializedRoots! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 9/27/2010 14:51'!
nextInteger
	^ integerMaterializer materializeOn: stream! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 9/27/2010 14:50'!
nextReferencedObject 

	| referenceIndex |
	referenceIndex := integerMaterializer materializeOn: stream.
	^ materializedInstances at: referenceIndex.! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 9/11/2010 19:09'!
referenceMaterializingActions
	^ referenceMaterializingActions! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 9/27/2010 14:44'!
register: aClusterSerializer

	clusterSerializers at: aClusterSerializer id put: aClusterSerializer. ! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/6/2010 19:50'!
stream
	^ stream! !

!FLMaterializer methodsFor: 'accessing' stamp: 'sd 9/8/2010 15:23'!
stream: aStream
	stream:= aStream.! !

Object subclass: #FLReferencesAnalyzer
	instanceVariableNames: 'clusteredInstances objectCount clusteredClassesAndTraits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLReferencesAnalyzer methodsFor: 'analysis' stamp: 'MartinDias 9/27/2010 16:51'!
analyzeAll: aCollection
	aCollection 
		do: [ :anObject | anObject fuelAccept: self ]
! !

!FLReferencesAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/4/2010 23:33'!
clusteredClassesAndTraits
	
	^ clusteredClassesAndTraits ! !

!FLReferencesAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 9/21/2010 00:05'!
clusteredInstances
	
	^ clusteredInstances! !

!FLReferencesAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 10/4/2010 23:33'!
initialize 

	clusteredInstances := Dictionary new.
	clusteredClassesAndTraits := Dictionary new.
	objectCount := 0.

! !

!FLReferencesAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 9/20/2010 23:57'!
objectCount
	^ objectCount! !

!FLReferencesAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 10/7/2010 00:06'!
visitClass: aClass
	"TODO: improve design"

	| set |

	set := clusteredClassesAndTraits 
		at: aClass fuelSerializer   
		ifAbsentPut: [ Set new ].

	(set includes: aClass)
		ifFalse: [
			set add: aClass.
			objectCount := objectCount + 1 ]! !

!FLReferencesAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 10/6/2010 20:58'!
visitCompiledMethod: aCompiledMethod

	self visitObject: aCompiledMethod.! !

!FLReferencesAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 10/5/2010 11:27'!
visitMetaclass: aMetaclass

	| set |
	set := clusteredInstances 
		at: aMetaclass fuelSerializer   
		ifAbsentPut: [ Set new ].

	(set includes: aMetaclass)
		ifFalse: [
			set add: aMetaclass.
			aMetaclass soleInstance fuelAccept: self.		
			objectCount := objectCount + 1 ]! !

!FLReferencesAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 9/28/2010 13:27'!
visitNilTrueFalse: anObject
	"TODO: improve this. nil, true and false are unique so we could visit them in a more optimum way"

	| set |
	set := clusteredInstances 
		at: anObject fuelSerializer   
		ifAbsentPut: [ OrderedCollection new ].

	(set includes: anObject)
		ifFalse: [
			set add: anObject.
			objectCount := objectCount + 1 ]! !

!FLReferencesAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 10/4/2010 22:19'!
visitObject: anObject

	| set |
	set := clusteredInstances 
		at: anObject fuelSerializer   
		ifAbsentPut: [ IdentitySet new ].

	(set includes: anObject)
		ifFalse: [
			set add: anObject.
			objectCount := objectCount + 1.
			anObject class fuelAccept: self.
			anObject fuelAllInstanceVariablesAccept: self ]! !

!FLReferencesAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 10/4/2010 23:33'!
visitTrait: aTrait
	"TODO: improve design"

	| set |
	set := clusteredClassesAndTraits 
		at: aTrait fuelSerializer   
		ifAbsentPut: [ Set new ].

	(set includes: aTrait)
		ifFalse: [
			set add: aTrait.
			objectCount := objectCount + 1 ]! !

Object subclass: #FLSerializer
	instanceVariableNames: 'stream instanceIndexes referenceSerializingActions integerSerializer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLSerializer class methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 14:59'!
on: aWriteStream

	| serializer |
	serializer := self new.
	serializer stream: aWriteStream.
	^serializer.! !

!FLSerializer methodsFor: 'initialize-release' stamp: 'MartinDias 10/4/2010 22:48'!
initialize 

	instanceIndexes := IdentityDictionary new.
	referenceSerializingActions := OrderedCollection new.! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 9/11/2010 18:53'!
instanceIndexes
	^ instanceIndexes! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 9/27/2010 14:53'!
nextPutInteger: anInteger

	integerSerializer serialize: anInteger on: stream! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 9/27/2010 14:52'!
nextPutReferenceTo: anObject

	integerSerializer serialize: (instanceIndexes at: anObject) on: stream! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 9/11/2010 19:01'!
referenceSerializingActions
	^referenceSerializingActions! !

!FLSerializer methodsFor: 'serializing' stamp: 'MartinDias 9/22/2010 14:36'!
serializeAll: rootsCollection
	
	self serializeInstances: rootsCollection.
	self serializeReferences.
	self serializeRoots: rootsCollection.
! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 10/4/2010 22:50'!
serializeClustered: clusteredInstances

	clusteredInstances
		keysAndValuesDo: [ :serializer :instances | 
			stream nextWordPut: serializer id.
			serializer serializeAll: instances on: stream mainSerializer: self.
			instances
				do: [ :instance | instanceIndexes at: instance put: instanceIndexes size + 1] ]! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 10/4/2010 23:33'!
serializeInstances: rootsCollection

	| analyzer clusteredInstances objectCount clusteredClasses |
	
	analyzer:= FLReferencesAnalyzer new 
		analyzeAll: rootsCollection;
		yourself.

	clusteredClasses := analyzer clusteredClassesAndTraits.		
	clusteredInstances := analyzer clusteredInstances.
	objectCount := analyzer objectCount.

	integerSerializer := objectCount fuelSerializer.
	stream nextWordPut: integerSerializer id. 
	
	self nextPutInteger: objectCount.
	self nextPutInteger: clusteredClasses size + clusteredInstances size.

	self serializeClustered: clusteredClasses. 	
	self serializeClustered: clusteredInstances. ! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 9/11/2010 19:04'!
serializeReferences

	referenceSerializingActions 
		do: [ :aBlock | aBlock value ]! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 10/4/2010 23:01'!
serializeRoots: rootsCollection

	self nextPutInteger: rootsCollection size.
	rootsCollection
		do: [ :instance | self nextPutReferenceTo: instance ]! !

!FLSerializer methodsFor: 'accessing' stamp: 'sd 9/8/2010 14:59'!
stream
	^ stream! !

!FLSerializer methodsFor: 'accessing' stamp: 'sd 9/8/2010 14:59'!
stream: anObject
	stream := anObject! !

!Object methodsFor: '*Fuel-analysis' stamp: 'MartinDias 9/27/2010 16:49'!
fuelAccept: aVisitor

	aVisitor visitObject: self.
! !

!Object methodsFor: '*Fuel-analysis' stamp: 'MartinDias 9/27/2010 16:50'!
fuelAllInstanceVariablesAccept: aVisitor

	self class isVariable 
		ifTrue: [ 
			1 to: self basicSize 
				do: [ :index | (self basicAt: index) fuelAccept: aVisitor ] ].
			
	1 to: self class instSize 
		do: [ :index | (self instVarAt: index) fuelAccept: aVisitor ]! !

!Object methodsFor: '*Fuel' stamp: 'MartinDias 9/24/2010 01:36'!
fuelSerializer

	^ FLObjectClusterSerializer for: self class! !

Object subclass: #Pair
	instanceVariableNames: 'left right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!Pair methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/28/2010 13:38'!
= aPair
	(aPair isKindOf: Pair)
		ifTrue: [ ^ self left == aPair left and: [ self right == aPair right ] ].
	^ false! !

!Pair methodsFor: 'as yet unclassified' stamp: 'MartinDias 9/28/2010 13:38'!
hash
	^ self left hash bitXor: self right identityHash! !

!Pair methodsFor: 'accessing' stamp: 'MartinDias 9/16/2010 19:58'!
left
	^ left! !

!Pair methodsFor: 'accessing' stamp: 'MartinDias 9/16/2010 19:58'!
left: anObject
	left := anObject! !

!Pair methodsFor: 'accessing' stamp: 'MartinDias 9/16/2010 19:58'!
right
	^ right! !

!Pair methodsFor: 'accessing' stamp: 'MartinDias 9/16/2010 19:58'!
right: anObject
	right := anObject! !

Object subclass: #Titi
	instanceVariableNames: 'name surname age'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!Titi classSide methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/23/2010 09:31'!
with: aName with: aSurname with: anAge
	|titi|
	titi:=Titi new.
	titi name:aName.
	titi surname:aSurname.
	titi age:anAge.
	^titi! !

!Titi methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/23/2010 09:00'!
= aTiti

	(aTiti isKindOf: Titi)ifTrue:[
		^ ((aTiti age=self age) and:[aTiti name1=self name1])and:[aTiti surname=self surname].
		].
		^false! !

!Titi methodsFor: 'accessing' stamp: 'TristanBourgois 9/23/2010 08:59'!
age
	^ age! !

!Titi methodsFor: 'accessing' stamp: 'TristanBourgois 9/23/2010 08:59'!
age: anObject
	age := anObject! !

!Titi methodsFor: 'accessing' stamp: 'TristanBourgois 9/23/2010 08:59'!
name1
	^ name! !

!Titi methodsFor: 'accessing' stamp: 'TristanBourgois 9/23/2010 08:59'!
name: anObject
	name := anObject! !

!Titi methodsFor: 'accessing' stamp: 'TristanBourgois 9/23/2010 09:00'!
surname
	^ surname! !

!Titi methodsFor: 'accessing' stamp: 'TristanBourgois 9/23/2010 09:00'!
surname: anObject
	surname := anObject! !

!Titi methodsFor: 'as yet unclassified' stamp: 'TristanBourgois 9/23/2010 09:06'!
with: aName with: aSurname with: anAge

	name:=aName.
	surname:=aSurname.
	age:=anAge.! !
